---
title: 'Comma operator (,)'
slug: Web/JavaScript/Reference/Operators/Comma_Operator
tags:
  - Comma
  - Compound
  - Expression
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p>The<strong> comma operator</strong> (<strong><code>,</code></strong>) evaluates each of its operands (from left to right) and returns the value of the last operand. This lets you create a compound expression in which multiple expressions are evaluated, with the compound expression's final value being the value of the rightmost of its member expressions. This is commonly used to provide multiple parameters to a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a></code> loop.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-commaoperators.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>expr1</em>, <em>expr2, expr3...</em></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>expr1</code>, <code>expr2</code>, <code>expr3</code>...</dt>
 <dd>One or more expressions, the last of which is returned as the value of the compound expression.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can use the comma operator when you want to include multiple expressions in a location that requires a single expression. The most common usage of this operator is to supply multiple parameters in a <code>for</code> loop.</p>

<p>The comma operator is fully different from the comma within arrays, objects, and function arguments and parameters.</p>

<h2 id="Examples">Examples</h2>

<p>If <code>a</code> is a 2-dimensional array with 10 elements on each side, the following code uses the comma operator to increment <code>i</code> and decrement <code>j</code> at once.</p>

<p>The following code prints the values of the diagonal elements in the array:</p>

<pre class="brush:js;highlight:[1] notranslate">for (var i = 0, j = 9; i &lt;= 9; i++, j--)
  console.log('a[' + i + '][' + j + '] = ' + a[i][j]);</pre>

<p>Note that the comma operators in assignments may appear not to have the normal effect of comma operators because they don't exist within an expression. In the following example, <code>a</code> is set to the value of <code>b = 3</code> (which is 3), but the <code>c = 4</code> expression still evaluates and its result returned to console (i.e., 4). This is due to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence">operator precedence and associativity</a>.</p>

<pre class="brush: js notranslate">var a, b, c;

a = b = 3, c = 4; // Returns 4 in console
console.log(a); // 3 (left-most)

var x, y, z;

x = (y = 5, z = 6); // Returns 6 in console
console.log(x); // 6 (right-most)
</pre>

<h3 id="Processing_and_then_returning">Processing and then returning</h3>

<p>Another example that one could make with comma operator is processing before returning. As stated, only the last element will be returned but all others are going to be evaluated as well. So, one could do:</p>

<pre class="brush: js notranslate">function myFunc() {
  var x = 0;

  return (x += 1, x); // the same as return ++x;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-comma-operator', 'Comma operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.comma")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for"><code>for</code> loop</a></li>
</ul>
